function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class LocalStorage {
  constructor() {
    _defineProperty(this, "storage", new Map());
  }

  get(state) {
    if (!state) {
      return;
    }

    const key = "kc-callback-".concat(state);
    let value;

    if (this.storage.has(key)) {
      value = this.storage.get(key);
    }

    this.clearExpired();
    return value;
  }

  add(state) {
    this.clearExpired();
    const key = "kc-callback-".concat(state.state);
    this.storage.set(key, _objectSpread(_objectSpread({}, state), {}, {
      expires: new Date().getTime() + 60 * 60 * 1000
    }));
  }

  clearExpired() {
    const time = new Date().getTime();
    Array.from(this.storage.entries()).filter(([key, state]) => key.startsWith('kc-callback-') && (!state.expires || state.expires < time)).map(([key]) => key).forEach(keyToRemove => {
      this.storage.delete(keyToRemove);
    });
  }

}

export default LocalStorage;
//# sourceMappingURL=storage.js.map